import numpy as np

def RK4sys(f, y_0, t_0, t_f, N):
    h = (t_f - t_0) / N
    # Ensure that any list/tuple returned from f_ is wrapped as array
    f_ = lambda t, y: np.asarray(f(t, y))
    y = np.zeros((N+1, len(y_0)))
    t = np.linspace(t_0, t_f, len(y))
    y[0] = y_0
    for n in range(0, N):
        k1=f_(t[n], y[n]);
        k2=f_(t[n] + 0.5*h, y[n] + 0.5*h*k1);
        k3=f_(t[n] + 0.5*h, y[n] + 0.5*h*k2);
        k4=f_(t[n] + h, y[n] + h*k3);
        y[n+1]=y[n]+h*(1./6*k1+1./3*k2+1./3*k3+1./6*k4); 

    return h, t, y