import numpy as np

def expliciteuler(f,y_0,t_0,t_f,N):
    h = (t_f-t_0)/N
    t_n = np.linspace(t_0,t_f, N+1)
    y = np.zeros(len(t_n))
    y[0] = y_0
    ## Numerical solution by Explicit Euler method
    for i in range(0, N):
        y[i+1] = y[i] + h*f(t_n[i], y[i])
    return h, t_n, y